--- old/usr/src/tools/smatch/src/smatch_modification_hooks.c	Mon Aug  5 08:38:37 2019
+++ new/usr/src/tools/smatch/src/smatch_modification_hooks.c	Mon Aug  5 08:38:37 2019
@@ -52,9 +52,12 @@
 	struct modification_data *data;
 	char *name;
 
-	state = __alloc_smatch_state(0);
 	expr = strip_expr(expr);
 	name = expr_to_str(expr);
+	if (!name)
+		return NULL;
+
+	state = __alloc_smatch_state(0);
 	state->name = alloc_sname(name);
 	free_string(name);
 
@@ -178,7 +181,7 @@
 	call_modification_hooks_name_sym(name, sym, expr, BOTH);
 	__in_fake_assign--;
 
-	other_name = map_long_to_short_name_sym(name, sym, &other_sym);
+	other_name = get_other_name_sym(name, sym, &other_sym);
 	if (other_name) {
 		__in_fake_assign++;
 		call_modification_hooks_name_sym(other_name, other_sym, expr, BOTH);
@@ -279,6 +282,8 @@
 {
 	my_id = id;
 
+	set_dynamic_states(my_id);
+
 	hooks = malloc((num_checks + 1) * sizeof(*hooks));
 	memset(hooks, 0, (num_checks + 1) * sizeof(*hooks));
 	hooks_late = malloc((num_checks + 1) * sizeof(*hooks));
